10 '   DXTEST.BAS version 1.2 - Copyrigh (C 1986,198 b Clark Green K1J  NO FO COMMERCIA USE
20 '
30 '   This Microsoft (tm) BASIC program will build a complete log package for the ARRL International DX Test.
40 '
50 '   The file containing the log entries must be an ASCII file in the following format: 
60 '               (each band requires a separate log entry file)
70 '
80 '          TIME         CALLSIGN            RCV'D REPORT  (each log entry must be followed by a carriage return)
90 '
100 '   At least one space must be between each field of each log entry. Only a changed digit in the time field must
110 '   be present; for example, if the contest begins at 1800Z and the first contact is made at 1802Z and the second
120 '   contact is made at 1805Z, then only 5 need be entered in the time field. If the third contact is made at
130 '   1812Z, then 12 should be entered in the time field. If the next contact is made at 1812Z, then no number need be
140 '   entered in the time field (however, be sure to enter a space to indicate separation between fields).
150 '
160 '   These files will be produced:
170 '            <filename>.LOG - this is a complete log ready for printing
180 '            <filename>.DUP - this is a sorted duplicate listing ready for printing
190 '            <filename>.SUM - this is a summary sheet ready for printing
200 '
210 '
220 '	Depending on the version of BASIC for your particular machine, the CLS (Clear Screen) command must
230 '   be changed.  Consult your own computer's BASIC documentation for more information.
240 '
250 '
260 '   If compiling (a VERY good idea for several orders of magnitude improvement in speed), use O and E switches 
270 '
280 '   This program also uses a prefix library file (DXPREFIX.LIB), which MUST be on the same disc (and in the
290 '   same subdirectory) as this program.
300 '
310 '
320 WARNING$="Copyrigh (C 1986,198 b Clark Green K1J  NO FO COMMERCIA USE"
330 '
340 DEFINT A-Z : OPTION BASE 1
350 DIM ENTRY$(1500), MULT$(175), PFX$(900), CTRY$(900), WIERDPFX$(50), WIERDCTRY$(50), AMBCTRY$(10), Q(175)
360 BLANK$=" " : BL$="" : SLANT$="/" : TRUE=-1
370 DUPE$="- Duplicate QSO -" : NEWCTRY$=" - Mult. #" : INVALID$="- Invalid QSO -"
380 '  Define format strings for printouts
390 LOGFORM$="   \      \  \  \    \            \   \   \    \    \    \                    \"
400 DUPFORM$="     \          \   \          \   \          \   \          \   \          \"
410 SUMFORM$="     \          \   \          \   \          \   \          \   \          \"
420 '
430 CLS
440 PRINT TAB(27) "ARRL DX Test Log Processor" : PRINT : PRINT
450 '
460 '  Read Prefix table file
470 PRINT TAB(5)  "Reading prefix library...  ";
480 I=0						                 ' initialize array subscript
490 OPEN "DXPREFIX.LIB" FOR INPUT AS #1
500  WHILE NOT EOF(1)
510   I=I+1
520   INPUT #1, PFX$(I), CTRY$(I), DUMMY$, DUMMY$		 ' DUMMY$ is a dummy variable for unused data
530   WEND
540 CLOSE
550 TABLESIZE=I					                 ' prefix table length
560 PRINT "done"
570 '
580 '  Get user input
590 PRINT : PRINT TAB(5) "What is the station callsign?  ";
600  INPUT "", MYCALL$
610 PRINT : PRINT TAB(5) "What is the two letter abbreviation for the station's state?  ";
620  INPUT "", MYSTATE$
630   IF LEN(MYSTATE$)<>2 THEN PRINT CHR$(7);: GOTO 610
640 PRINT : PRINT TAB(5) "What is the beginning date of the contest? <dd/mm/yr> ";
650  INPUT "", STARTDATE$
660   MARK=INSTR(STARTDATE$,"/") : IF MARK=0 THEN MARK=INSTR(STARTDATE$,"-")
670   STARTDAY=VAL(LEFT$(STARTDATE$,MARK-1))
680   STARTDATE$=RIGHT$(STARTDATE$,LEN(STARTDATE$)-MARK)
690   MARK=INSTR(STARTDATE$,"/") : IF MARK=0 THEN MARK=INSTR(STARTDATE$,"-")
700   MON=VAL(LEFT$(STARTDATE$,MARK-1))
710    IF MON=2 THEN MON$=" Feb.  " : RST$="599" ELSE MON$=" Mar.  " : RST$="59"
720    SENT$=RST$+MYSTATE$
730   YR$=RIGHT$(STARTDATE$,LEN(STARTDATE$)-MARK)
740 PRINT : PRINT TAB(5) "What is the GMT starting time for the contest?  ";
750  INPUT "", STARTGMT$
760 PRINT : PRINT TAB(5) "What file is the log extract located in?  ";
770  INPUT "", INFILE$ : GOSUB 2440                              ' check to see if file is valid
780  IF INSTR(INFILE$,".")<>0 THEN OUTFILE$=LEFT$(INFILE$,INSTR(INFILE$,".")-1) ELSE OUTFILE$=INFILE$
790 PRINT : PRINT TAB(5) "What frequency band is the log extract for?  ";
800  INPUT "", BAND$
810 '
820 CLS
830 PRINT : PRINT TAB(5) "Duping and counting...  ";
840 '
850 '  Clear arrays
860 FOR I=1 TO 1500
870  ENTRY$(I)=BL$
880  NEXT I
890 FOR I=1 TO 175
900  MULT$(I)=BL$
910  Q(I)=1
920  NEXT I
930 '
940 '  Initialize variables
950 RAWTOTAL=0 : QSOS=0 : DUPES=0 : INVALIDS=0 : MULTNR=0
960 DAY=STARTDAY : PREVIOUSGMT$=STARTGMT$
970 '
980 '  Open files for data input and .LOG output
990 OPEN INFILE$ FOR INPUT AS #1
1000 OPEN OUTFILE$+".LOG" FOR OUTPUT AS #2
1010 '
1020 ' Collect log data, process, and enter into output file
1030   WHILE NOT EOF(1)
1040    LINE INPUT #1, THISENTRY$		                 ' read entire line from disc file
1050    WHILE ASC(RIGHT$(THISENTRY$,1))<48 AND LEN(THISENTRY$)>0
1060     THISENTRY$=LEFT$(THISENTRY$,LEN(THISENTRY$)-1)          ' strip off trailing spaces,etc
1070     WEND
1080    IF LEN(THISENTRY$)>0 THEN RAWTOTAL=RAWTOTAL+1 ELSE GOTO 1610
1090 '
1100 '  Separate received report from THISENTRY$
1110   RCVD$=BL$						 ' initialize RCVD$ to be null string
1120   WHILE ASC(RIGHT$(THISENTRY$,1))>=48
1130    RCVD$=RIGHT$(THISENTRY$,1)+RCVD$
1140    THISENTRY$=LEFT$(THISENTRY$,LEN(THISENTRY$)-1)		 ' parse last character of string
1150    WEND
1160   IF LEN(RCVD$)<=3 THEN RCVD$=RST$+RCVD$			 ' if signal report is left out, append std. report
1170   WHILE ASC(RIGHT$(THISENTRY$,1))<48
1180    THISENTRY$=LEFT$(THISENTRY$,LEN(THISENTRY$)-1)           ' strip off trailing spaces,etc
1190    WEND
1200 '
1210 '  Separate GMT from THISENTRY$
1220   WHILE ASC(LEFT$(THISENTRY$,1))<48
1230    THISENTRY$=RIGHT$(THISENTRY$,LEN(THISENTRY$)-1)          ' strip off leading spaces
1240    WEND
1250   IF INSTR(THISENTRY$,BLANK$)<>0 THEN GMT$=LEFT$(THISENTRY$,INSTR(THISENTRY$,BLANK$)-1) ELSE GMT$=BL$
1260   THISENTRY$=RIGHT$(THISENTRY$,(LEN(THISENTRY$)-LEN(GMT$)))
1270   WHILE LEFT$(THISENTRY$,1)=BLANK$
1280    THISENTRY$=RIGHT$(THISENTRY$,LEN(THISENTRY$)-1)          ' strip off leading spaces
1290    WEND
1300 '  Fill in missing time data 
1310   GMT$=LEFT$(PREVIOUSGMT$,(4-LEN(GMT$)))+GMT$
1320   THEDATE$=BL$ : IF GMT$<PREVIOUSGMT$ THEN DAY=DAY+1 : THEDATE$=STR$(DAY)+MON$
1330 '
1340 '  Check for dupes
1350   DUPE.QSO=NOT TRUE : NOTE$=BL$                             ' blank note
1360   FOR I=1 TO QSOS
1370    IF THISENTRY$=ENTRY$(I) THEN NOTE$=DUPE$ : DUPES=DUPES+1 : DUPE.QSO=TRUE : I=QSOS
1380    NEXT I
1390    IF DUPE.QSO GOTO 1550                                    ' skip over prefix search if this entry is a dupe
1400   QSOS=QSOS+1 : ENTRY$(QSOS)=THISENTRY$
1410 '
1420 '  Determine prefix and search prefix library for contact country
1430   IF INSTR(THISENTRY$,SLANT$)>0 THEN GOSUB 2540 ELSE THISPFX$=LEFT$(THISENTRY$,4)
1440   GOSUB 2670 : IF NOT INLIST THEN GOSUB 2810
1450   IF THISCTRY$="W" OR THISCTRY$="VE" THEN NOTE$=INVALID$ : INVALIDS=INVALIDS+1 : GOTO 1550
1460   IF ASC(THISCTRY$)<48 THEN GOSUB 3050                      ' resolve ambiguous prefix
1470 '
1480 '  Search multiplier table for new multiplier
1490   NEWMULT=TRUE						 ' initially call contact a new multiplier
1500   FOR I=1 TO MULTNR
1510    IF MULT$(I)=THISCTRY$ THEN Q(I)=Q(I)+1 : NEWMULT=NOT TRUE : J=MULTNR
1520    NEXT I
1530    IF NEWMULT THEN MULTNR=MULTNR+1 : MULT$(MULTNR)=THISCTRY$ : NOTE$=THISCTRY$+NEWCTRY$+STR$(MULTNR)
1540 '
1550 '  Write entry to file  
1560   IF (RAWTOTAL-1) MOD 50=0 THEN GOSUB 3270			 ' print header if this is the beginning of a page
1570   PRINT #2, USING LOGFORM$; THEDATE$; GMT$; THISENTRY$; SENT$; RCVD$; NOTE$
1580   IF RAWTOTAL MOD 50=0 THEN PRINT #2, CHR$(12)       	 ' print a form feed if this is the end of a page
1590 '  Reset variables for next entry
1600   PREVIOUSGMT$=GMT$ : GMT$=BL$
1610  WEND
1620 IF RAWTOTAL MOD 50<>0 THEN PRINT #2, CHR$(12)               ' if a form feed hasn't been printed, print one
1630 CLOSE
1640 PRINT "done"
1650 '
1660 '  Build dupe sheet
1670  PRINT : PRINT TAB(5) "Preparing dupe sheet...  ";
1680 '  Sort callsigns for dupe sheet
1690 M=QSOS\2
1700 WHILE M>0
1710  FOR I=M+1 TO QSOS
1720   J=I-M
1730   WHILE J>0
1740    IF ENTRY$(J)>ENTRY$(J+M) THEN SWAP ENTRY$(J),ENTRY$(J+M) : J=J-M ELSE J=0
1750    WEND
1760   NEXT I
1770  M=M\2
1780  WEND
1790 '
1800 '  Enter dupe sheet into file
1810 OPEN OUTFILE$+".DUP" FOR OUTPUT AS #1
1820  IF QSOS MOD 250=0 THEN LASTPAGE=QSOS\250 ELSE LASTPAGE=QSOS\250+1
1830 FOR PAGE=1 TO LASTPAGE
1840  PRINT #1, SPC(20-(LEN(MYCALL$)+LEN(BAND$))/2); MYCALL$; " -- Dupe Sheet for ";
1850   PRINT #1, BAND$; " MHz Band -- Page"; STR$(PAGE)
1860  PRINT #1, BL$ : PRINT #1, BL$
1870  FOR ROW=1 TO 50
1880   E=(PAGE-1)*250+ROW
1890   PRINT #1, USING DUPFORM$; ENTRY$(E); ENTRY$(E+50); ENTRY$(E+100); ENTRY$(E+150); ENTRY$(E+200)
1900   NEXT ROW
1910  PRINT #1, CHR$(12)                         		 ' go to next page
1920  NEXT PAGE
1930 CLOSE
1940 PRINT "done"
1950 '
1960 '  Build summary listing
1970 PRINT : PRINT TAB(5) "Preparing summary sheet...  ";
1980 '  Sort multipliers for summary sheet
1990 M=MULTNR\2
2000 WHILE M>0
2010  FOR I=M+1 TO MULTNR
2020   J=I-M
2030   WHILE J>0
2040    IF MULT$(J)>MULT$(J+M) THEN SWAP MULT$(J),MULT$(J+M) : SWAP Q(J),Q(J+M) : J=J-M ELSE J=0
2050    WEND
2060   NEXT I
2070  M=M\2
2080  WEND
2090 '
2100 '  Append number of qsos per country onto country prefixes
2110 FOR I=1 TO MULTNR
2120  MULT$(I)=MULT$(I)+SPACE$(6-LEN(MULT$(I)))+" -"+STR$(Q(I))
2130  NEXT I
2140 '
2150 '  Enter summary sheet into file
2160 OPEN OUTFILE$+".SUM" FOR OUTPUT AS #1
2170  PRINT #1, SPC(14-(LEN(MYCALL$)+LEN(BAND$))/2); MYCALL$; " -- Summary Sheet for "; BAND$;
2180   PRINT #1, " MHz Band - "; YR$; " ARRL DX Test" 
2190  PRINT #1, BL$
2200  PRINT #1, TAB(15); "Country Listing and number of contacts per Country"
2210  PRINT #1, BL$ : PRINT #1, BL$
2220  IF MULTNR MOD 5=0 THEN LASTROW=MULTNR\5 ELSE LASTROW=MULTNR\5+1
2230  FOR ROW=1 TO LASTROW
2240   PRINT #1, USING SUMFORM$; MULT$(ROW); MULT$(ROW+LASTROW); MULT$(ROW+LASTROW*2); MULT$(ROW+LASTROW*3); MULT$(ROW+LASTROW*4)
2250   NEXT ROW
2260  PRINT #1, BL$ : PRINT #1, BL$ : PRINT #1, BL$
2270  PRINT #1, TAB(18) "Total Valid QSOs - "; STR$(QSOS-INVALIDS); TAB(45)"Dupes - "; STR$(DUPES)
2280  PRINT #1, TAB(18) "Countries - "; STR$(MULTNR)
2290 CLOSE
2300 PRINT "done"
2310 '
2320 '  Print results
2330 CLS : PRINT CHR$(7)
2340 PRINT : PRINT TAB(5) "Results for the "; BAND$; " MHz band" 
2350 PRINT : PRINT TAB(8) "Valid QSOs: "; QSOS-INVALIDS
2360 PRINT : PRINT TAB(8) "Duplicate QSOs: "; DUPES
2370 PRINT : PRINT TAB(8) "Countries: "; MULTNR
2380 PRINT : PRINT : PRINT 
2390 PRINT TAB(5) "Type C to continue with another band for this contest,"
2400 PRINT : PRINT TAB(5) "or any other key to Exit   ";
2410 ANS$=INPUT$(1)
2420  IF ANS$="C" OR ANS$="c" THEN CLS : GOTO 760 ELSE CLS : SYSTEM
2430 '
2440 '  Subroutine to trap missing file
2450 ON ERROR GOTO 2500
2460 OPEN INFILE$ FOR INPUT AS #1                		 ' try opening file
2470 ON ERROR GOTO 0
2480 CLOSE
2490 RETURN
2500 PRINT CHR$(7) : PRINT TAB(4) "That file does not exist - type X to Exit or any other key to continue ";
2510 ANS$=INPUT$(1) : IF ANS$="X" OR ANS$="x" THEN CLS : SYSTEM
2520 PRINT 
2530 RESUME 760
2540 '
2550 '  Subroutine to determine prefix from portable designator
2560  MARK=INSTR(THISENTRY$,SLANT$)
2570  IF MARK>3 THEN THISPFX$=RIGHT$(THISENTRY$,LEN(THISENTRY$)-MARK) ELSE THISPFX$=LEFT$(THISENTRY$,MARK-1)
2580  IF LEN(THISPFX$)>1 GOTO 2650               		 ' have prefix - return
2590  IF ASC(THISPFX$)>58 OR ASC(THISPFX$)<47 THEN THISPFX$=LEFT$(THISENTRY$,4) : GOTO 2650 ' (local portable designator)
2600  K=2                                        		 ' find position of first numeral in call
2610   WHILE (ASC(MID$(THISENTRY$,K,1))>57 OR ASC(MID$(THISENTRY$,K,1))<48) AND K<LEN(THISENTRY$)
2620    K=K+1
2630    WEND
2640   THISPFX$=LEFT$(THISENTRY$,K-1)+THISPFX$     		 ' new prefix = portable number in old prefix
2650  RETURN
2660 '
2670 '  Subroutine to search prefix library for standard country prefix
2680   K=4 : INLIST=NOT TRUE : SAVEDPFX$=THISPFX$
2690   WHILE K>0 AND INLIST=NOT TRUE
2700    THISPFX$=LEFT$(THISPFX$,K)
2710    LOW=1 : HIGH=TABLESIZE : INLIST=NOT TRUE                 ' initial values for binary sort
2720    WHILE LOW<=HIGH AND INLIST=NOT TRUE
2730     L=(LOW+HIGH)\2
2740     IF THISPFX$=PFX$(L) THEN INLIST=TRUE : THISCTRY$=CTRY$(L)
2750     IF THISPFX$<PFX$(L) THEN HIGH=L-1 ELSE LOW=LOW+1
2760     WEND
2770    K=K-1
2780    WEND
2790   RETURN
2800 '
2810 '  Subroutine to search unusual prefix list 
2820  IF NRWIERDPFX=0 GOTO 2930					 ' if the supplementary prefix list is empty, skip ahead
2830   K=4
2840   WHILE K>0
2850    SAVEDPFX$=LEFT$(SAVEDPFX$,K)
2860    FOR J=1 TO NRWIERDPFX
2870     IF SAVEDPFX$=WIERDPFX$(J) THEN INLIST=TRUE : THISCTRY$=WIERDCTRY$(J) : J=NRWIERDPFX : K=1
2880     NEXT J
2890    K=K-1
2900    WEND
2910   IF INLIST THEN RETURN				  	 ' if the prefix was found, return
2920 '
2930 '  Routine to get prefix definition and continent from user for prefix not found in library
2940  PRINT CHR$(7) : PRINT
2950  PRINT TAB(5) "The prefix for "; THISENTRY$; " can't be found in the prefix library."
2960  PRINT : PRINT TAB(8) "What is the callsign prefix?  "; 
2970   INPUT "", HELDPFX$
2980  PRINT : PRINT TAB(8) "What standard prefix is that equivalent to?  ";
2990   INPUT "", THISPFX$
3000   GOSUB 2670 : IF NOT INLIST GOTO 2940
3010   NRWIERDPFX=NRWIERDPFX+1 : WIERDPFX$(NRWIERDPFX)=HELDPFX$ : WIERDCTRY$(NRWIERDPFX)=THISCTRY$
3020  PRINT : PRINT TAB(5) "Back to duping and counting...  ";
3030  RETURN
3040 '
3050 '  Subroutine to resolve ambiguous prefix with user interaction
3060  THISCTRY$=RIGHT$(THISCTRY$,LEN(THISCTRY$)-1)               ' strip initial delimiter
3070   J=0
3080   WHILE LEN(THISCTRY$)>0
3090    J=J+1
3100    MARK=INSTR(THISCTRY$,".")
3110    AMBCTRY$(J)=LEFT$(THISCTRY$,MARK-1)                      ' put multipiler name into array
3120    THISCTRY$=RIGHT$(THISCTRY$,LEN(THISCTRY$)-MARK)
3130    WEND
3140  PRINT CHR$(7) : PRINT
3150  PRINT TAB(5) "The prefix for "; THISENTRY$; " could indicate several different countries."
3160  PRINT : PRINT TAB(8) "The possiblities are:" : PRINT
3170  FOR K=1 TO J
3180   PRINT TAB(11) STR$(K); ". "; AMBCTRY$(K)                  ' print choices to screen
3190   NEXT K
3200  PRINT : PRINT TAB(8) "Type the number of the correct country. > ";
3210   INPUT "", CHOICE$
3220   K=VAL(CHOICE$) : IF K > J OR K < 1 THEN PRINT CHR$(7); : GOTO 3200
3230  THISCTRY$=AMBCTRY$(K)
3240  PRINT : PRINT TAB(5) "Back to duping and counting...  ";
3250  RETURN
3260 '
3270 '  Subroutine to print log sheet header
3280  PRINT #2, BL$
3290  PRINT #2, TAB(5); MYCALL$; "  "; BAND$; " MHz Log"; TAB(70); "Page"; STR$(RAWTOTAL\50+1)
3300  PRINT #2, BL$
3310  PRINT #2, "     Date    Time    Callsign         Sent     Rcv'd           Notes"  
3320  PRINT #2, "   "; STRING$(74,61)
3330  THEDATE$=STR$(DAY)+MON$
3340  RETURN 
