10 '   VHFLOG.BAS version 1.3 - Copyrigh (C 1986,198 b Clark Green K1J  NO FO COMMERCIA USE
20 '
30 '   This Microsoft (tm) BASIC program will build a complete log package for any of the ARRL VHF Contests.
40 '
50 '   The file containing the log entries must be an ASCII file in the following format: 
60 '               (each band requires a separate log entry file)
70 '
80 '          TIME         CALLSIGN            RCV'D GRID SQUARE   (each log entry must be followed by a carriage return)
90 '
100 '   At least one space must be between each field of each log entry. Only a changed digit in the time field must
110 '   be present; for example, if the contest begins at 1800Z and the first contact is made at 1802Z and the second
120 '   contact is made at 1805Z, then only 5 need be entered in the time field. If the third contact is made at
130 '   1812Z, then 12 should be entered in the time field. If the next contact is made at 1812Z, then no number need be
140 '   entered in the time field (however, be sure to enter a space to indicate separation between fields).
150 '
160 '   These files will be produced:
170 '            <filename>.LOG - this is a complete log ready for printing
180 '            <filename>.DUP - this is a sorted duplicate listing ready for printing
190 '            <filename>.SUM - this is a summary sheet ready for printing
200 '
210 '
220 '	Depending on the version of BASIC for your particular machine, the CLS (Clear Screen) command must
230 '   be changed.  Consult your own computer's BASIC documentation for more information.
240 '
250 '
260 '   If compiling (a VERY good idea for several orders of magnitude improvement in speed), use O and E switches 
270 '
280 '
290 '
300 WARNING$="Copyrigh (C 1986,198 b Clark Green K1J  NO FO COMMERCIA USE"
310 '
320 '  Define arrays and variables
330 DEFINT A-Z : OPTION BASE 1
340 DIM ENTRY$(1500), GRID$(1500), MULT$(250), Q(250), MONTH$(12)
350 BLANK$=" " : BL$="" : TRUE=-1
360 MONTH$(1)="Jan." : MONTH$(2)="Feb." : MONTH$(3)="Mar." : MONTH$(4)="Apr."
370 MONTH$(5)="May" : MONTH$(6)="June" : MONTH$(7)="July" : MONTH$(8)="Aug."
380 MONTH$(9)="Sept." : MONTH$(10)="Oct." : MONTH$(11)="Nov." : MONTH$(12)="Dec."
390 DUPE$="- Duplicate QSO -" : DIFGRID$="Station in new Grid" : NEWGRID$=" - Mult. #"
400 '  Define format strings for printouts
410 LOGFORM$="   \       \ \  \     \           \     \  \     \  \     \                   \"
420 DUPFORM$="      \         \   \          \   \          \   \          \   \          \"
430 SUMFORM$="     \         \    \         \    \         \    \         \    \         \"
440 '
450 '  Get information from user
460 CLS
470 PRINT TAB(27) " VHF Contest Log Processor " : PRINT : PRINT
480 PRINT : PRINT TAB(5) "What is the station callsign?  ";
490  INPUT "", MYCALL$
500 PRINT : PRINT TAB(5) "What Grid Square is the station in?  ";
510  INPUT "", MYGRID$
520   IF LEN(MYGRID$)<>4 THEN PRINT CHR$(7);: GOTO 500
530 PRINT : PRINT TAB(5) "What is the beginning date of the contest? <dd/mm/yr> ";
540  INPUT "", STARTDATE$
550   MARK=INSTR(STARTDATE$,"/") : IF MARK=0 THEN MARK=INSTR(STARTDATE$,"-")
560    STARTDAY=VAL(LEFT$(STARTDATE$,MARK-1))
570    STARTDATE$=RIGHT$(STARTDATE$,LEN(STARTDATE$)-MARK)
580   MARK=INSTR(STARTDATE$,"/") : IF MARK=0 THEN MARK=INSTR(STARTDATE$,"-")
590    MON$=MONTH$(VAL(LEFT$(STARTDATE$,MARK-1)))
600    YR$=RIGHT$(STARTDATE$,LEN(STARTDATE$)-MARK)
610 PRINT : PRINT TAB(5) "What is the GMT starting time for the contest?  ";
620  INPUT "", STARTGMT$
630 PRINT : PRINT TAB(5) "What file is the log extract located in?  ";
640  INPUT "", INFILE$
650  GOSUB 2270					                 ' check to see if file exists
660  IF INSTR(INFILE$,".")<>0 THEN OUTFILE$=LEFT$(INFILE$,INSTR(INFILE$,".")-1) ELSE OUTFILE$=INFILE$
670 PRINT : PRINT TAB(5) "What frequency band is the log extract for?  ";
680  INPUT "", BAND$
690 '
700 '  Collect log extract from input file and assign data to arrays
710 CLS
720 PRINT : PRINT TAB(5) "Duping and counting...  ";
730 '
740 '  Clear arrays
750 FOR I=1 TO 1500
760  ENTRY$(I)=BL$
770  GRID$(I)=BL$
780  NEXT I
790 FOR I=1 TO 250
800  MULT$(I)=BL$
810  Q(I)=1
820  NEXT I
830 '
840 '  Initialize variables
850 RAWTOTAL=0 : QSOS=0 : DUPES=0 : MULTNR=0			                 ' initialize counters
860 DAY=STARTDAY : PREVIOUSGMT$=STARTGMT$                        ' (re)set starting time and day
870 '
880 '  Open input data file and output .LOG file
890 OPEN INFILE$ FOR INPUT AS #1
900 OPEN OUTFILE$+".LOG" FOR OUTPUT AS #2
910 '
920 '  Input data, process, and enter into output file
930  WHILE NOT EOF(1)
940   LINE INPUT #1, THISENTRY$			                 ' read entire line from disc file
950    WHILE ASC(RIGHT$(THISENTRY$,1))<48 AND LEN(THISENTRY$)>0
960     THISENTRY$=LEFT$(THISENTRY$,LEN(THISENTRY$)-1)           ' strip off trailing spaces,etc
970     WEND
980   IF LEN(THISENTRY$)>0 THEN RAWTOTAL=RAWTOTAL+1 ELSE GOTO 1420
990 '
1000 '  Separate grid from THISENTRY$
1010   THISGRID$=RIGHT$(THISENTRY$,4)
1020   THISENTRY$=LEFT$(THISENTRY$,LEN(THISENTRY$)-4)
1030   WHILE ASC(RIGHT$(THISENTRY$,1))<48
1040    THISENTRY$=LEFT$(THISENTRY$,LEN(THISENTRY$)-1)           ' strip off trailing spaces
1050    WEND
1060 '
1070 '  Separate GMT from THISENTRY$
1080   WHILE ASC(LEFT$(THISENTRY$,1))<48
1090    THISENTRY$=RIGHT$(THISENTRY$,LEN(THISENTRY$)-1)          ' strip off leading spaces
1100    WEND
1110   IF INSTR(THISENTRY$,BLANK$)<>0 THEN GMT$=LEFT$(THISENTRY$,INSTR(THISENTRY$,BLANK$)-1) ELSE GMT$=BL$
1120   THISENTRY$=RIGHT$(THISENTRY$,(LEN(THISENTRY$)-LEN(GMT$)))
1130   WHILE LEFT$(THISENTRY$,1)=BLANK$
1140    THISENTRY$=RIGHT$(THISENTRY$,LEN(THISENTRY$)-1)          ' strip off leading spaces
1150    WEND
1160 '  Fill in missing time data 
1170  GMT$=LEFT$(PREVIOUSGMT$,(4-LEN(GMT$)))+GMT$
1180  THEDATE$=BL$ : IF GMT$<PREVIOUSGMT$ THEN DAY=DAY+1 : THEDATE$=STR$(DAY)+BLANK$+MON$
1190 '
1200 '  Check for dupes
1210  DUPE.QSO=NOT TRUE : NOTE$=BL$	               	 	 ' clear note field
1220  FOR I=1 TO QSOS
1230   IF THISENTRY$=ENTRY$(I) AND THISGRID$<>GRID$(I) THEN NOTE$=DIFGRID$
1240   IF THISENTRY$=ENTRY$(I) AND THISGRID$=GRID$(I) THEN NOTE$=DUPE$ : DUPES=DUPES+1 : DUPE.QSO=TRUE : I=QSOS
1250   NEXT I
1260   IF DUPE.QSO GOTO 1360					 ' if contact is a dupe, skip over multiplier search
1270   QSOS=QSOS+1 : ENTRY$(QSOS)=THISENTRY$ : GRID$(QSOS)=THISGRID$
1280 '
1290 '  Check for multipliers
1300  NEWMULT=TRUE						 ' initially set multiplier flag true
1310  FOR I=1 TO MULTNR
1320   IF MULT$(I)=THISGRID$ THEN Q(I)=Q(I)+1 : NEWMULT=NOT TRUE : J=MULTNR
1330   NEXT I
1340   IF NEWMULT THEN MULTNR=MULTNR+1 : MULT$(MULTNR)=THISGRID$ : NOTE$=THISGRID$+NEWGRID$+STR$(MULTNR)
1350 '
1360 '  Write entry to file
1370    IF (RAWTOTAL-1) MOD 50=0 THEN GOSUB 2400	         ' print the header if this is the beginning of a page
1380   PRINT #2, USING LOGFORM$; THEDATE$; GMT$; THISENTRY$; MYGRID$; THISGRID$; NOTE$
1390    IF RAWTOTAL MOD 50=0 THEN PRINT #2, CHR$(12)	         ' print a form feed if this is the end of the page
1400 '  Update variables for next entry
1410   PREVIOUSGMT$=GMT$ : GMT$=BL$
1420  WEND
1430 IF RAWTOTAL MOD 50 <>0 THEN PRINT #2, CHR$(12)              ' if a form feed wasn't printed, print one now
1440 CLOSE
1450 PRINT "done"
1460 '
1470 '  Build dupe sheet
1480 PRINT : PRINT TAB(5) "Preparing dupe sheet...  ";
1490 '
1500 '  Sort callsigns for dupe sheet
1510 M=QSOS\2
1520 WHILE M>0
1530  FOR I=M+1 TO QSOS
1540   J=I-M
1550   WHILE J>0
1560    IF ENTRY$(J)>ENTRY$(J+M) THEN SWAP ENTRY$(J),ENTRY$(J+M) : J=J-M ELSE J=0
1570    WEND
1580   NEXT I
1590  M=M\2
1600  WEND
1610 '
1620 '  Enter dupe sheet into file
1630 OPEN OUTFILE$+".DUP" FOR OUTPUT AS #1
1640  IF QSOS MOD 250=0 THEN LASTPAGE=QSOS\250 ELSE LASTPAGE=QSOS\250+1
1650 FOR PAGE=1 TO LASTPAGE
1660  PRINT #1, SPC(20-(LEN(MYCALL$)+LEN(BAND$))/2); MYCALL$; " -- Dupe Sheet for "; BAND$; " MHz Band -- Page"; STR$(PAGE)
1670  PRINT #1, BL$ : PRINT #1, BL$
1680  FOR ROW=1 TO 50
1690   E=(PAGE-1)*250+ROW
1700   PRINT #1, USING DUPFORM$; ENTRY$(E); ENTRY$(E+50); ENTRY$(E+100); ENTRY$(E+150); ENTRY$(E+200)
1710   NEXT ROW
1720  PRINT #1, CHR$(12)			                 ' go to next page
1730  NEXT PAGE
1740 CLOSE
1750 PRINT "done"
1760 '
1770 '  Build summary listing
1780 PRINT : PRINT TAB(5) "Preparing summary sheet...  ";
1790 '
1800 '  Sort multipliers for summary sheet
1810 M=MULTNR\2
1820 WHILE M>0
1830  FOR I=M+1 TO MULTNR
1840   J=I-M
1850   WHILE J>0
1860    IF MULT$(J)>MULT$(J+M) THEN SWAP MULT$(J),MULT$(J+M) : SWAP Q(J),Q(J+M) : J=J-M ELSE J=0
1870    WEND
1880   NEXT I
1890  M=M\2
1900  WEND
1910 '
1920 '  Append QSO per grid number to Grid Square
1930  FOR I=1 TO MULTNR
1940   MULT$(I)=MULT$(I)+" - "+STR$(Q(I))
1950   NEXT I
1960 '
1970 '  Enter summary sheet into file
1980 OPEN OUTFILE$+".SUM" FOR OUTPUT AS #1
1990  PRINT #1, SPC(12-(LEN(MYCALL$)+LEN(BAND$)+LEN(MON$))/2); MYCALL$; " -- Summary Sheet for "; BAND$;
2000   PRINT #1, " MHz Band -  "; MON$; " "; YR$; " VHF Contest" 
2010  PRINT #1, BL$
2020  PRINT #1, TAB(13); "Grid Square Listing and number of contacts per Grid"
2030  PRINT #1, BL$ : PRINT #1, BL$
2040  IF MULTNR MOD 5=0 THEN LASTROW=MULTNR\5 ELSE LASTROW=MULTNR\5+1
2050  FOR ROW=1 TO LASTROW
2060   PRINT #1, USING SUMFORM$; MULT$(ROW); MULT$(ROW+LASTROW); MULT$(ROW+LASTROW*2); MULT$(ROW+LASTROW*3); MULT$(ROW+LASTROW*4)
2070   NEXT ROW
2080  PRINT #1, BL$ : PRINT #1, BL$ : PRINT #1, BL$
2090  PRINT #1, TAB(18); "Total Valid QSOs - "; STR$(QSOS); TAB(45); "Dupes - "; STR$(DUPES)
2100  PRINT #1, TAB(18); "Grid Squares - "; STR$(MULTNR)
2110  PRINT #1, CHR$(12)
2120 CLOSE
2130 PRINT "done"
2140 '
2150 '  Print results
2160 CLS : PRINT CHR$(7)
2170 PRINT : PRINT TAB(5) "Results for the "; BAND$; " MHz band" 
2180 PRINT : PRINT TAB(8) "Valid QSOs: "; QSOS
2190 PRINT : PRINT TAB(8) "Duplicate QSOs: "; DUPES
2200 PRINT : PRINT TAB(8) "Grid Squares: "; MULTNR
2210 PRINT : PRINT : PRINT 
2220 PRINT TAB(5) "Type C to continue with another band for this contest,"
2230 PRINT : PRINT TAB(5) "or any other key to Exit  ";
2240 ANS$=INPUT$(1)
2250  IF ANS$="C" OR ANS$="c" THEN CLS : GOTO 630 ELSE CLS : SYSTEM
2260 '
2270 '  Subroutine to trap missing file
2280 ON ERROR GOTO 2340
2290 OPEN INFILE$ FOR INPUT AS #1		                 ' try opening file
2300 ON ERROR GOTO 0
2310 CLOSE
2320 RETURN
2330 '
2340 '  Error trap for missing file
2350 PRINT CHR$(7) : PRINT TAB(4) "That file does not exist - type X to Exit or any other key to continue ";
2360 ANS$=INPUT$(1) : IF ANS$="X" OR ANS$="x" THEN CLS : SYSTEM
2370 PRINT 
2380 RESUME 630
2390 '
2400 '  Subroutine to print log sheet header
2410 PRINT #2, BL$
2420 PRINT #2, TAB(5); MYCALL$; " "; BAND$; " MHz Log"; TAB(70); "Page"; STR$(RAWTOTAL\50+1)
2430 PRINT #2, BL$
2440 PRINT #2, "     Date    Time     Callsign          Sent     Rcvd           Notes"
2450 PRINT #2, "   "; STRING$(74,61)
2460 THEDATE$=STR$(DAY)+BLANK$+MON$
2470 RETURN
