10 '   IARULOG.BAS version 1.2 -  Copyrigh (C 1986,198 b Clark Green K1J  NO FO COMMERCIA USE
20 '
30 '   This Microsoft (tm) BASIC program will build a complete log package for the IARU HF Championship.
40 '
50 '   The file containing the log entries must be an ASCII file in the following format: 
60 '               (each band requires a separate log entry file)
70 '
80 '          TIME         CALLSIGN            RCV'D REPORT  (each log entry must be followed by a carriage return)
90 '
100 '   At least one space must be between each field of each log entry. Only a changed digit in the time field must
110 '   be present; for example, if the contest begins at 1800Z and the first contact is made at 1802Z and the second
120 '   contact is made at 1805Z, then only 5 need be entered in the time field. If the third contact is made at
130 '   1812Z, then 12 should be entered in the time field. If the next contact is made at 1812Z, then no number need be
140 '   entered in the time field (however, be sure to enter a space to indicate separation between fields).
150 '
160 '   These files will be produced:
170 '            <filename>.LOG - this is a complete log ready for printing
180 '            <filename>.DUP - this is a sorted duplicate listing ready for printing
190 '            <filename>.SUM - this is a summary sheet ready for printing
200 '
210 '
220 '	Depending on the version of BASIC for your particular machine, the CLS (Clear Screen) command must
230 '   be changed.  Consult your own computer's BASIC documentation for more information.
240 '
250 '
260 '   If compiling (a VERY good idea for several orders of magnitude improvement in speed), use O and E switches 
270 '
280 '   This program also uses a prefix library file (DXPREFIX.LIB), which MUST be on the same disc (and in the
290 '   same subdirectory) as this program.
300 '
310 '
320 WARNING$="Copyrigh (C 1986,198 b Clark Green K1J  NO FO COMMERCIA USE"
330 '
340 '  Define arrays and variables
350 DEFINT A-Z : OPTION BASE 1
360 DIM ENTRY$(1500), MULT$(100), PFX$(1000), CNT$(1000), WIERDPFX$(50), WIERDCNT$(50), Q(100)
370 BLANK$=" " : BL$="" : SLANT$="/" : TRUE=-1
380 DUPE$="- Duplicate QSO -" : NEWZONE$="    Mult. #"
390 CONTINENTS$="AFASEUNAOCSA"
400 '  Define format strings for printouts
410 LOGFORM$="   \      \  \  \   \           \    \   \    \        \ #   \                \"
420 DUPFORM$="      \         \   \          \   \          \   \          \   \          \"
430 SUMFORM$="     \         \    \         \    \         \    \         \    \         \"
440 '
450 CLS
460 PRINT TAB(24) "IARU HF Competition Log Processor" : PRINT : PRINT
470 '
480 '  Read Prefix table file
490 PRINT TAB(5)  "Reading prefix library...  ";
500 I=0						                 ' initialize array subscript
510 OPEN "DXPREFIX.LIB" FOR INPUT AS #1
520  WHILE NOT EOF(1)
530   I=I+1
540   INPUT #1, PFX$(I), DUMMY$, DUMMY$, CNT$(I)		 ' DUMMY$ is a dummy variable for unused data
550   WEND
560 CLOSE
570 TABLESIZE=I					                 ' prefix table length
580 PRINT "done"
590 '
600 '  Get user input
610 PRINT : PRINT TAB(5) "What is the station callsign?  ";
620  INPUT "", MYCALL$
630   THISENTRY$=MYCALL$ : IF INSTR(THISENTRY$,SLANT$)>0 THEN GOSUB 2740 ELSE THISPFX$=LEFT$(THISENTRY$,4)
640   GOSUB 2870 : IF NOT INLIST THEN GOSUB 3010		 ' if the prefix can't be found in table, look elsewhere
650   MYCNT$=THISCNT$
660 PRINT : PRINT TAB(5) "What is the station's zone?  ";
670  INPUT "", MYZONE$
680   IF VAL(MYZONE$)>=1 AND VAL(MYZONE$)<=75 GOTO 710
690    PRINT CHR$(7) : PRINT TAB(8) "Is '"; MYZONE$; "' correct? <Y/N>  ";
700    INPUT "", ANS$ : IF ANS$<>"Y" AND ANS$<>"y" GOTO 660
710   IF VAL(MYZONE$)<10 AND LEN(MYZONE$)=1 THEN MYZONE$="0"+MYZONE$
720 PRINT : PRINT TAB(5) "What is the beginning date of the contest? <dd/mm/yr> ";
730  INPUT "", STARTDATE$
740   MARK=INSTR(STARTDATE$,"/") : IF MARK=0 THEN MARK=INSTR(STARTDATE$,"-")
750   STARTDAY=VAL(LEFT$(STARTDATE$,MARK-1))
760   STARTDATE$=RIGHT$(STARTDATE$,LEN(STARTDATE$)-MARK)
770   MARK=INSTR(STARTDATE$,"/") : IF MARK=0 THEN MARK=INSTR(STARTDATE$,"-")
780   MON$=" July  "
790   YR$=RIGHT$(STARTDATE$,LEN(STARTDATE$)-MARK)
800 PRINT : PRINT TAB(5) "What is the GMT starting time for the contest?  ";
810  INPUT "", STARTGMT$
820 PRINT : PRINT TAB(5) "What file is the log extract located in?  ";
830  INPUT "", INFILE$ : GOSUB 2640                              ' check to see if file is valid
840  IF INSTR(INFILE$,".")<>0 THEN OUTFILE$=LEFT$(INFILE$,INSTR(INFILE$,".")-1) ELSE OUTFILE$=INFILE$
850 PRINT : PRINT TAB(5) "What frequency band is the log extract for?  ";
860  INPUT "", BAND$
870 PRINT : PRINT TAB(5) "Which mode is the log extract for?"
880  PRINT TAB(5) "  [Type 1 for CW or 2 for Phone]  ";
890  INPUT "", MODE
900  IF MODE=1 THEN RST$="599" ELSE RST$="59"
910  SENT$=RST$+MYZONE$
920 '
930 '  Build log file
940 CLS
950 PRINT : PRINT TAB(5) "Duping and counting...  ";
960 '
970 '  Clear arrays
980 FOR I=1 TO 1500
990  ENTRY$(I)=BL$
1000  NEXT I
1010 FOR I=1 TO 100
1020  MULT$(I)=BL$
1030  Q(I)=1
1040  NEXT I
1050 '
1060 '  Initialize variables
1070 RAWTOTAL=0 : QSOS=0 : DUPES=0 : MULTNR=0 : TOTPOINTS=0
1080 DAY=STARTDAY : PREVIOUSGMT$=STARTGMT$
1090 '
1100 '  Open input file and ouput .LOG file
1110 OPEN INFILE$ FOR INPUT AS #1
1120 OPEN OUTFILE$+".LOG" FOR OUTPUT AS #2
1130 '
1140 '  Input data, process, and enter into output file
1150  WHILE NOT EOF(1)
1160   LINE INPUT #1, THISENTRY$			         ' read entire line from disc file
1170    WHILE ASC(RIGHT$(THISENTRY$,1))<48 AND LEN(THISENTRY$)>0
1180     THISENTRY$=LEFT$(THISENTRY$,LEN(THISENTRY$)-1)          ' strip off trailing spaces,etc
1190     WEND
1200   IF LEN(THISENTRY$)>0 THEN RAWTOTAL=RAWTOTAL+1 ELSE GOTO 1790
1210 '
1220 '  Separate received report from THISENTRY$
1230   RCVD$=BL$						 ' initialize rcvd field to blank
1240   WHILE ASC(RIGHT$(THISENTRY$,1))>=48
1250    RCVD$=RIGHT$(THISENTRY$,1)+RCVD$
1260    THISENTRY$=LEFT$(THISENTRY$,LEN(THISENTRY$)-1)
1270    WEND
1280   IF LEN(RCVD$)<(LEN(RST$)+2) OR ASC(RCVD$)>=65 THEN RCVD$=RST$+RCVD$
1290   WHILE ASC(RIGHT$(THISENTRY$,1))<48
1300    THISENTRY$=LEFT$(THISENTRY$,LEN(THISENTRY$)-1)           ' strip off trailing spaces,etc
1310    WEND
1320 '
1330 '  Separate GMT from THISENTRY$
1340   WHILE ASC(LEFT$(THISENTRY$,1))<48
1350    THISENTRY$=RIGHT$(THISENTRY$,LEN(THISENTRY$)-1)          ' strip off leading spaces
1360    WEND
1370   IF INSTR(THISENTRY$,BLANK$)<>0 THEN GMT$=LEFT$(THISENTRY$,INSTR(THISENTRY$,BLANK$)-1) ELSE GMT$=BL$
1380   THISENTRY$=RIGHT$(THISENTRY$,(LEN(THISENTRY$)-LEN(GMT$)))
1390   WHILE LEFT$(THISENTRY$,1)=BLANK$
1400    THISENTRY$=RIGHT$(THISENTRY$,LEN(THISENTRY$)-1)          ' strip off leading spaces
1410    WEND
1420 '  Fill in missing time data 
1430   GMT$=LEFT$(PREVIOUSGMT$,(4-LEN(GMT$)))+GMT$
1440   THEDATE$=BL$ : IF GMT$<PREVIOUSGMT$ THEN DAY=DAY+1 : THEDATE$=STR$(DAY)+MON$
1450 '
1460 '  Check for dupes
1470   DUPE.QSO=NOT TRUE : NOTE$=BL$                             ' blank note
1480   FOR I=1 TO QSOS
1481    IF LEN(ENTRY$(I))<>LEN(THISENTRY$) GOTO 1500
1490    IF ENTRY$(I)=THISENTRY$ THEN NOTE$=DUPE$ : DUPES=DUPES+1 : POINTS=0 : DUPE.QSO=TRUE : I=QSOS
1500    NEXT I
1510     IF DUPE.QSO GOTO 1740                                   ' skip over prefix search if this entry is a dupe
1520    QSOS=QSOS+1 : ENTRY$(QSOS)=THISENTRY$
1530 '
1540 '  Determine "zone" and search through multiplier table
1550   THISZONE$=RIGHT$(RCVD$,LEN(RCVD$)-LEN(RST$))
1560   NEWMULT=TRUE						 ' initially call contact a new multiplier
1570   FOR I=1 TO MULTNR
1580    IF MULT$(I)=THISZONE$ THEN Q(I)=Q(I)+1 : NEWMULT=NOT TRUE : I=MULTNR
1590    NEXT I
1600    IF NEWMULT THEN MULTNR=MULTNR+1 : MULT$(MULTNR)=THISZONE$ : NOTE$=NEWZONE$+STR$(MULTNR)
1610    IF ASC(THISZONE$)>=65 OR THISZONE$=MYZONE$ THEN POINTS=1 : GOTO 1710
1620 '
1630 '  Determine prefix and search prefix library for contact continent
1640   IF INSTR(THISENTRY$,SLANT$)>0 THEN GOSUB 2740 ELSE THISPFX$=LEFT$(THISENTRY$,4)
1650   GOSUB 2870 : IF NOT INLIST THEN GOSUB 3010		 ' if the prefix can't be found in table, look elsewhere
1660 '
1670 '  Resolve USA prefix ambiguities (i.e. KG6=Guam vs. KG6=Calif.) and calculate points
1680   IF LEFT$(THISPFX$,1)="K" AND (VAL(THISZONE$)=6 OR VAL(THISMULT$)=7 OR VAL(THISMULT$)=8) THEN THISCNT$="NA"
1690   IF THISCNT$=MYCNT$ THEN POINTS=3 ELSE POINTS=5
1700 '
1710 '  Total QSO points
1720   TOTPOINTS=TOTPOINTS+POINTS
1730 '
1740 '  Write entry to file  
1750    IF (RAWTOTAL-1) MOD 50=0 THEN GOSUB 3290		 ' print header if this is the beginning of a page
1760   PRINT #2, USING LOGFORM$; THEDATE$; GMT$; THISENTRY$; SENT$; RCVD$; POINTS; NOTE$
1770    IF RAWTOTAL MOD 50=0 THEN PRINT #2, CHR$(12)	         ' print a form feed if this is the end of a page
1780   PREVIOUSGMT$=GMT$ : GMT$=BL$
1790  WEND
1800 IF RAWTOTAL MOD 50<>0 THEN PRINT #2, CHR$(12)               ' if a form feed hasn't been printed, print one now
1810 CLOSE
1820 PRINT "done"
1830 '
1840 '  Build dupe sheet
1850  PRINT : PRINT TAB(5) "Preparing dupe sheet...  ";
1860 '  Sort callsigns for dupe sheet
1870 M=QSOS\2
1880 WHILE M>0
1890  FOR I=M+1 TO QSOS
1900   J=I-M
1910   WHILE J>0
1920    IF ENTRY$(J)>ENTRY$(J+M) THEN SWAP ENTRY$(J),ENTRY$(J+M) : J=J-M ELSE J=0
1930    WEND
1940   NEXT I
1950  M=M\2
1960  WEND
1970 '
1980 '  Enter dupe sheet into file
1990 OPEN OUTFILE$+".DUP" FOR OUTPUT AS #1
2000  IF QSOS MOD 250=0 THEN LASTPAGE=QSOS\250 ELSE LASTPAGE=QSOS\250+1
2010 FOR PAGE=1 TO LASTPAGE
2020  PRINT #1, SPC(20-(LEN(MYCALL$)+LEN(BAND$))/2); MYCALL$; " -- Dupe Sheet for ";
2030   PRINT #1, BAND$; " MHz Band -- Page"; STR$(PAGE)
2040  PRINT #1, BL$ : PRINT #1, BL$
2050  FOR ROW=1 TO 50
2060   E=(PAGE-1)*250+ROW
2070   PRINT #1, USING DUPFORM$; ENTRY$(E); ENTRY$(E+50); ENTRY$(E+100); ENTRY$(E+150); ENTRY$(E+200)
2080   NEXT ROW
2090  PRINT #1, CHR$(12)                         		 ' go to next page
2100  NEXT PAGE
2110 CLOSE
2120 PRINT "done"
2130 '
2140 '  Build summary listing
2150 PRINT : PRINT TAB(5) "Preparing summary sheet...  ";
2160 '  Sort multipliers for summary sheet
2170 M=MULTNR\2
2180 WHILE M>0
2190  FOR I=M+1 TO MULTNR
2200   J=I-M
2210   WHILE J>0
2220    IF MULT$(J)>MULT$(J+M) THEN SWAP MULT$(J),MULT$(J+M) : SWAP Q(J),Q(J+M) : J=J-M ELSE J=0
2230    WEND
2240   NEXT I
2250  M=M\2
2260  WEND
2270 '
2280 '  Append number of qsos per zone onto zone numbers
2290 FOR I=1 TO MULTNR
2300  MULT$(I)=MULT$(I)+SPACE$(6-LEN(MULT$(I)))+" -"+STR$(Q(I))
2310  NEXT I
2320 '
2330 '  Enter summary sheet into file
2340 OPEN OUTFILE$+".SUM" FOR OUTPUT AS #1
2350  PRINT #1, SPC(8-(LEN(MYCALL$)+LEN(BAND$))/2); MYCALL$; " -- Summary Sheet for "; BAND$;
2360   PRINT #1, " MHz Band - "; YR$; " IARU HF Championship" 
2370  PRINT #1, BL$
2380  PRINT #1, TAB(11); "Multiplier Listing and number of contacts per multiplier"
2390  PRINT #1, BL$ : PRINT #1, BL$
2400  IF MULTNR MOD 5=0 THEN LASTROW=MULTNR\5 ELSE LASTROW=MULTNR\5+1
2410  FOR ROW=1 TO LASTROW
2420   PRINT #1, USING SUMFORM$; MULT$(ROW); MULT$(ROW+LASTROW); MULT$(ROW+LASTROW*2); MULT$(ROW+LASTROW*3); MULT$(ROW+LASTROW*4)
2430   NEXT ROW
2440  PRINT #1, BL$ : PRINT #1, BL$ : PRINT #1, BL$
2450  PRINT #1, TAB(17); "Total Valid QSOs - "; STR$(QSOS); TAB(45); "Dupes - "; STR$(DUPES)
2460  PRINT #1, TAB(17); "Total QSO points - "; STR$(TOTPOINTS)
2470  PRINT #1, TAB(17); "Multipliers - "; STR$(MULTNR)
2480 CLOSE
2490 PRINT "done"
2500 '
2510 '  Print results
2520 CLS : PRINT CHR$(7)
2530 PRINT : PRINT TAB(5) "Results for the "; BAND$; " MHz band" 
2540 PRINT : PRINT TAB(8) "Valid QSOs: "; QSOS
2550 PRINT : PRINT TAB(8) "Duplicate QSOs: "; DUPES
2560 PRINT : PRINT TAB(8) "Total QSO points: "; TOTPOINTS
2570 PRINT : PRINT TAB(8) "Multipliers: "; MULTNR
2580 PRINT : PRINT : PRINT 
2590 PRINT TAB(5) "Type C to continue with another band for this contest,"
2600 PRINT : PRINT TAB(5) "or any other key to Exit   ";
2610 ANS$=INPUT$(1)
2620  IF ANS$="C" OR ANS$="c" THEN CLS : GOTO 820 ELSE CLS : SYSTEM
2630 '
2640 '  Subroutine to trap missing file
2650 ON ERROR GOTO 2700
2660 OPEN INFILE$ FOR INPUT AS #1                		 ' try opening file
2670 ON ERROR GOTO 0
2680 CLOSE
2690 RETURN
2700 PRINT CHR$(7) : PRINT TAB(4) "That file does not exist - type X to Exit or any other key to continue ";
2710 ANS$=INPUT$(1) : IF ANS$="X" OR ANS$="x" THEN CLS : SYSTEM
2720 PRINT 
2730 RESUME 820
2740 '
2750 '  Subroutine to determine prefix from portable designator
2760  MARK=INSTR(THISENTRY$,SLANT$)
2770  IF MARK>3 THEN THISPFX$=RIGHT$(THISENTRY$,LEN(THISENTRY$)-MARK) ELSE THISPFX$=LEFT$(THISENTRY$,MARK-1)
2780  IF LEN(THISPFX$)>1 GOTO 2850               		 ' have prefix - return
2790  IF ASC(THISPFX$)>58 OR ASC(THISPFX$)<47 THEN THISPFX$=LEFT$(THISENTRY$,4) : GOTO 2850 ' (local portable designator)
2800  K=2                                        		 ' find position of first numeral in call
2810  WHILE (ASC(MID$(THISENTRY$,K,1))>57 OR ASC(MID$(THISENTRY$,K,1))<48) AND K<LEN(THISENTRY$)
2820   K=K+1
2830   WEND
2840  THISPFX$=LEFT$(THISENTRY$,K-1)+THISPFX$     		 ' new prefix = portable number in old prefix
2850  RETURN
2860 '
2870 '  Subroutine to determine station's continent from prefix
2880   K=4 : INLIST=NOT TRUE : SAVEDPFX$=THISPFX$
2890   WHILE K>0 AND INLIST=NOT TRUE
2900    THISPFX$=LEFT$(THISPFX$,K)
2910    LOW=1 : HIGH=TABLESIZE : INLIST=NOT TRUE                 ' initial values for binary sort
2920    WHILE LOW<=HIGH AND INLIST=NOT TRUE
2930     L=(LOW+HIGH)\2
2940     IF THISPFX$=PFX$(L) THEN INLIST=TRUE : THISCNT$=CNT$(L)
2950     IF THISPFX$<PFX$(L) THEN HIGH=L-1 ELSE LOW=L+1
2960     WEND
2970    K=K-1
2980    WEND
2990   RETURN
3000 '
3010 '  Subroutine to search unusual prefix list 
3020  IF NRWIERDPFX=0 GOTO 3130					 ' if the supplementary prefix list is empty, skip ahead
3030   K=4
3040   WHILE K>0
3050    SAVEDPFX$=LEFT$(SAVEDPFX$,K)
3060    FOR J=1 TO NRWIERDPFX
3070     IF SAVEDPFX$=WIERDPFX$(J) THEN INLIST=TRUE : THISCNT$=WIERDCNT$(J) : J=NRWIERDPFX : K=1
3080     NEXT J
3090    K=K-1
3100    WEND
3110   IF INLIST THEN RETURN				  	 ' if the prefix was found, return
3120 '
3130 '  Routine to get prefix definition and continent from user for prefix not found in library
3140  PRINT CHR$(7) : PRINT
3150  PRINT TAB(5) "The prefix for "; THISENTRY$; " can't be found in the prefix library."
3160  PRINT : PRINT TAB(8) "What is the callsign prefix?  "; 
3170   INPUT "", THISPFX$
3180   NRWIERDPFX=NRWIERDPFX+1 : WIERDPFX$(NRWIERDPFX)=THISPFX$
3190  PRINT : PRINT TAB(8) "What is the continent? [AF, AS, EU, NA, OC, SA]  ";
3200   INPUT "", THISCNT$
3210    FOR J=1 TO 11 STEP 2
3220     IF THISCNT$=MID$(CONTINENTS$,J,2) THEN INLIST=TRUE : J=11
3230     NEXT J                                                  ' check for valid continent name
3240    IF NOT INLIST THEN PRINT CHR$(7);: GOTO 3190
3250   WIERDCNT$(NRWIERDPFX)=THISCNT$
3260  PRINT : PRINT TAB(5) "Back to duping and counting...  ";
3270  RETURN
3280 '
3290 '  Subroutine to print log sheet header
3300  PRINT #2, BL$
3310  PRINT #2, TAB(5); MYCALL$; "  "; BAND$; " MHz Log"; TAB(70); "Page"; STR$(RAWTOTAL\50+1)
3320  PRINT #2, BL$
3330  PRINT #2, "     Date    Time   Callsign         Sent     Rcvd      Pt.        Notes"
3340  PRINT #2, "   "; STRING$(74,61)
3350  THEDATE$=STR$(DAY)+MON$
3360  RETURN 
